REM INFO: Stretch Edges.csc v2.42 (PP12)
REM Copyright  James Aswell, 2000-2006
REM 
REM DESCRIPTION:
REM Stretches the edges of an image creating a border effect.

BEGIN DIALOG OBJECT Dialog1 100, 60, "Edge Stretch"
	SPINCONTROL  46, 6, 50, 12, .SpinControl1
	SPINCONTROL  46, 23, 50, 12, .SpinControl2
	TEXT  4, 7, 40, 8, .Text1, "Vertical:"
	TEXT  3, 24, 40, 8, .Text2, "Horizontal:"
	OKBUTTON  4, 42, 92, 14, .OK1
END DIALOG

WITHOBJECT "CorelPhotoPaint.Automation.12"
ON ERROR GOTO ERRORHANDLER

	IF .GetDocumentCount() > 0 THEN
		Width = .GetDocumentWidth()
		Height = .GetDocumentHeight()

		With Dialog1
			.SpinControl1.SETMINRANGE 0
			.SpinControl1.SETMAXRANGE 30000 - Height
			.SpinControl2.SETMINRANGE 0
			.SpinControl2.SETMAXRANGE 30000 - Width
		End With

		retval% = Dialog(Dialog1)
	ENDIF

	IF retval% = 1 THEN
		With Dialog1
			x& = .SpinControl2.GETVALUE()
			y& = .SpinControl1.GETVALUE()
		End With

		.ImagePapersize Width+x&, Height+y&, 0, -y&, 5, 0, 0, 0, 0

		If .GetMaskPresent() = 1 Then
			maskpres@ = True
		
			'convert to a new channel
			.MaskChannelAdd "Mask Channel"
			.MaskRemove
		EndIf

		'select background only
		.ObjectEdit 0, FALSE

		.BitmapEffect "Offset", "OffsetEffect OffsetHShift=" & x& & ",OffsetVShift=" & y& & ",OffsetAsPercent=0,OffsetMode=1,OffsetCS=5:0:0:0"
		.BitmapEffect "Offset", "OffsetEffect OffsetHShift=" & -(x& / 2) & ",OffsetVShift=" & -(y& / 2) & ",OffsetAsPercent=0,OffsetMode=1,OffsetCS=5:0:0:0"


		If maskpres@ = True Then
			'convert channel to mask
			x& = .GetChannelCount()
			.MaskChannelToMask (x& - 1), 0
			.MaskChannelDelete (x& - 1)
		EndIf

	ENDIF

END WITHOBJECT

ERRORHANDLER:
SELECT CASE ERRNUM
	CASE 0
	CASE 603
		RESUME NEXT
	CASE ELSE
		MESSAGE "Unexpected Error:" + STR(ERRNUM)
		RESUME NEXT
END SELECT
